local alert = "!!! %s is hogging, %s !!!"

local foods = {
	[201352] = true, -- Lavish Suramar Feast
	[259410] = true, -- Bountiful Captain's Feast
	[286050] = true, -- Sanguinated Feast
	[259409] = true, -- Galley Banquet
}

local counts = {}
local endTimes = {}
local started = 0.000

local f = CreateFrame("Frame", "FEASTHOG", UIParent)
f:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
f:SetScript("OnEvent", function(self, event, unit, _, spellID)
	if event == "UNIT_SPELLCAST_SUCCEEDED" then
		if foods[spellID] then
			started = GetServerTime()
			self:RegisterEvent("UNIT_AURA")
			print("|cff33ff99FEASTHOG:|r Monitoring feast!")
		end
	else
		if GetServerTime() - started > 180 then
			return self:UnregisterEvent("UNIT_AURA")
		end
		local _, _, _, _, _, endTime = AuraUtil.FindAuraByName("Food & Drink", unit)
		if endTime then
			local name, server = UnitName(unit)
			if server and server ~= "" then
				name = name.."-"..server
			end
			local t = endTimes[name]
			if t and t ~= endTime and endTime - t < 18.000 then
				counts[name] = 1 + (counts[name] or 0)
				if counts[name] > 1 then
					print("|cff33ff99FEASTHOG:|r", format(alert, name, counts[name]))
				end
			end
			endTimes[name] = endTime
		end
	end
end)